$extend(OS.ext, {
    'matchType': function(type_name, arg) {
        switch(type_name) {
            case 'string': return $type(arg) == 'string';
            case 'int': return ($type(arg) == 'number') && (!arg.toString().contains('.'));
            case 'float': return ($type(arg) == 'number') && (arg.toString().contains('.'));
            case 'array': return ($type(arg) == 'array');
            case 'object': return ($type(arg) == 'object');
        }
        return eval('arg instanceof ' + type_name);
    },
    'overload': function(map) {
        var args = [];
        var fns = [];
        var ns = [];
        for(key in map) {
            args.push(key.split(' '));
            fns.push(map[key]);
            ns.push(ns.length);
        }
        return function() {
            var passed = $A(arguments);
            var nargs = ns.filter(function(n) { return args[n].length == passed.length; });
            var targs = nargs.filter(function(n) { 
                return args[n].every(function(b, i) {
                    return matchType(b, passed[i]);
                })
            });
            if (targs.length == 1) {
                return fns[targs[0]].pass(passed,this).call();
            }
            return false;
        }
    }
});