<?php
class Application_Status extends PBEnum
{
  const RC  = 0;
  const II  = 1;
}
class Application_Depend extends PBMessage
{
  var $wired_type = PBMessage::WIRED_STRING;
  public function __construct($reader=null)
  {
    parent::__construct($reader);
    $this->fields["1"] = "PBString";
    $this->values["1"] = "";
  }
  function id()
  {
    return $this->_get_value("1");
  }
  function set_id($value)
  {
    return $this->_set_value("1", $value);
  }
}
class Application extends PBMessage
{
  var $wired_type = PBMessage::WIRED_STRING;
  public function __construct($reader=null)
  {
    parent::__construct($reader);
    $this->fields["1"] = "PBString";
    $this->values["1"] = "";
    $this->fields["2"] = "PBString";
    $this->values["2"] = "";
    $this->fields["3"] = "PBString";
    $this->values["3"] = "";
    $this->fields["4"] = "Application_Status";
    $this->values["4"] = "";
    $this->fields["5"] = "Application_Depend";
    $this->values["5"] = array();
  }
  function id()
  {
    return $this->_get_value("1");
  }
  function set_id($value)
  {
    return $this->_set_value("1", $value);
  }
  function label()
  {
    return $this->_get_value("2");
  }
  function set_label($value)
  {
    return $this->_set_value("2", $value);
  }
  function path()
  {
    return $this->_get_value("3");
  }
  function set_path($value)
  {
    return $this->_set_value("3", $value);
  }
  function state()
  {
    return $this->_get_value("4");
  }
  function set_state($value)
  {
    return $this->_set_value("4", $value);
  }
  function depends($offset)
  {
    return $this->_get_arr_value("5", $offset);
  }
  function add_depends()
  {
    return $this->_add_arr_value("5");
  }
  function depends_size()
  {
    return $this->_get_arr_size("5");
  }
}
class Apps extends PBMessage
{
  var $wired_type = PBMessage::WIRED_STRING;
  public function __construct($reader=null)
  {
    parent::__construct($reader);
    $this->fields["1"] = "Application";
    $this->values["1"] = array();
  }
  function apps($offset)
  {
    return $this->_get_arr_value("1", $offset);
  }
  function add_apps()
  {
    return $this->_add_arr_value("1");
  }
  function apps_size()
  {
    return $this->_get_arr_size("1");
  }
}
?>