<?php
/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

            v. 1.3
    Web 2.0 Operating System
*/
/**********************************************
 * File: login.php
 **********************************************/
$log_usr = htmlentities($_POST['log_usr']);
$log_pwd = htmlentities($_POST['log_pass']);
$path = $os_path.'/fs/'.$log_usr;
$login_file = $path.'/Data/login.ini';
$error='';

// Security: increase login time if failed more than 3 times
if(!isset($_SESSION['try'])){
    $_SESSION['try']=-2;
}
if($_SESSION['try']>0 && $_SESSION['sleep']){
    sleep($_SESSION['try']*mt_rand(1,2));
    $error .= '<div class="login_error">Error: You already made 3 login attempt</div>';
}

// Login
if($log_usr && $log_pwd){
    // Create directories
    if(!is_dir($os_path.'/fs')){
        if(!@mkdir($os_path.'/fs')) {
            $error .= '<div class="login_error">Error: Cannot create <b>fs/</b>: Permission denied</div>';
        }
        else{
            if(!@chmod($os_path.'/fs', 0774)) {
                $error .= '<div class="login_error">Error: Cannot chmod <b>fs/</b>: Permission denied</div>';
            }
            else {
                $error .= '<div class="login_error">Error: Permissions changed, please reload the page !</div>';
            }
        }
    }
    // Get user data and connect
	if(is_file($login_file)){
        //TODO: Use PB
		$user_info = parse_ini_file($login_file);
		$username = $user_info['username'];
		$password = $user_info['password'];
        
        // Check user directories
		if(@mkdir($path.'/Documents')){
            mkdir($path.'/Data');
            mkdir($path.'/Desktop');
        }
        
        // Check user infos
		if(md5($os_salt.$log_pwd)==$password){
            $os->user=$username;
            $os->path=$os_path;
            $os->relative_path = ($_SERVER['REQUEST_URI']!='/') ? $_SERVER['REQUEST_URI'] : '';
            $os->logged=true;
            // Redirect FIXME?
            header("Status: 301 Moved Permanently", false, 301);
            header("Location: .");
		}
		else{
			$error .= '<div class="login_error">Error: Your password is incorrect</div>';
		}
	}
	else{
		$error .= '<div class="login_error">Error: User does not exist !</div>';
        //TODO: Register
	}
    // Security
    if(!empty($error)){
        $_SESSION['try']+=1;
        $_SESSION['sleep']=true;
    }
}
?>
<head>
    <title><?php echo $os_name; ?></title>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <link rel="stylesheet" type="text/css" href="themes/default/css/login.css" />
</head>
<body>
	<div id="login_window">
	<h1 id="login_title"><?php echo $os_name; ?></h1>
		<form name="frmLogin" action="?" method="post">
			<div class="login_input">
				<label for="log_usr" class="login_input_l">Username</label>
                <div class="login_input_r">
                    <input type="text" id="log_usr" name="log_usr" value="user"<?php if($_GET['log']){
                        echo 'value="'.$_GET['log'].'"';
                    } ?>/>
                </div>
			</div>
			<div class="login_input">
				<label for="log_pass" class="login_input_l">Password</label>
				<div class="login_input_r"><input type="password" id="log_pass" value="user" name="log_pass" /></div>
			</div>
			<div class="login_input"><input type="submit" value="Ok" /></div>
		</form>
	</div>
    <?php echo $error; ?>
</body>
</html>
