<?php
/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

            v. 1.4
        Web Desktop System
*/
/**********************************************
 * File: User.class.php
 * Class: User
 * Extends ProtocolBuffers
 **********************************************/
class User extends ProtocolBuffers
{
/**********************************************
 * Method: pb_user_get
 * Get user informations
 *
 * Returns:
 *  User associative array
 **********************************************/
	public function pb_user_get()
	{
        $string = $this->pb_get('user.pb');
        $this->pb_require('user');
        $user = new User();
        $user->parseFromString($string);
        return array(
            'id' => $user->id,
            'login' => $user->login,
            'name' => $user->name,
            'email' => $user->email
        );
	}
}
?>