<?php
/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

            v. 1.3
    Web 2.0 Operating System
*/
/**********************************************
 * File: desktop.php
 **********************************************/
$styles=array(
    'themes/default/css/desktop.css',
    'themes/default/css/window.css',
    'themes/default/css/gui.css',
    'themes/default/css/widget.css'
);

ob_start("ob_gzhandler");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title><?php echo $os->user.'@'.$os_name; ?></title>
    <link href="themes/default/favicon.png" rel="icon" type="image/png" />
    <?php
    // Styles
	$styles = array_merge($styles, glob('programs/*/*.css'));
    if($os_distributed){
        $styles = $os->getFiles($styles);
    }
	foreach($styles as $style){
        echo '<link href="'.$style.'" rel="stylesheet" type="text/css"/>';
	}
    ?>
</head>
<body>

<noscript>
    <p class="noscript"><?php echo $os_name; ?>: JavaScript is Disabled</p>
</noscript>

<div id="os" style="display:none;">
    <div id="system"></div>
	<div id="system_info"></div>
    <div id="taskbar"></div>
	<div id="desktop"></div>
</div>

<script type="text/javascript">
    var user = '<?php echo $os->user; ?>';
    var session_id = '<?php echo $os->session_id; ?>';
</script>
<script type="text/javascript" src="Kernel/OS/Init.js"></script>

</body>
</html>
