<?php
/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

Version: 1.4
License: Public Domain http://creativecommons.org/licenses/publicdomain/
Author: Aubort Jean-Baptiste
*/
/**********************************************
 * File: index.php
 * Initialize the session and check login
 **********************************************/
include('./Kernel/config.php');
include('./Kernel/Server/Server.class.php');
$os = os::getInstance();

// Temp
if(isset($_GET['logout'])){
    $os->logout();
}

// Use SSL
if(!$os->sslInUse() && $os_use_ssl){
    $os->sslRedirect();
}

// Do login
if($os->logged){
	include('Kernel/Server/desktop.php');
}
else{
	include('Kernel/Server/login.php');
}
?>