<?php
/*
  _______    _      ____   _____ 
 |__   __|  | |    / __ \ / ____|
    | | __ _| | __| |  | | (___  
    | |/ _` | |/ /| |  | |\___ \ 
    | | (_| |   < | |__| |____) |
    |_|\__,_|_|\_\ \____/|_____/

            v. 1.3
    Web 2.0 Operating System
*/
/**********************************************
 * File: programs.php
 **********************************************/
include('Kernel/Server/Server.class.php');

include('Kernel/Server/ProtocolBuffers.class.php');
include('Kernel/Server/Programs.class.php');
$os = os::getInstance($_GET['session_id']);
$pb = new Programs($os);


$req = $_POST['req'];
$apps = $_POST['apps'];

if($req=='install')
{
    $apps = $pb->pb_apps_set($apps);
    if($apps)
    {
        $request[] = array('window_info', array('Programs: Install', array(
            'content'=>'<b>Installation complete !</b><br/>Restart for the changes to take effect. ',
            'childOf'=>'programs'
        )));
    }
    else
    {
        $request[] = array('window_info', array('Programs: Error', array(
            'content'=>$apps,
            'childOf'=>'programs'
        )));
    }
    echo $os->buildRequest($request);
}
?>