#!/bin/sh
# @author: Aubort Jean-Baptiste <aubort.jeanbaptiste@gmail.com> 21.11.2008
# Create a simple copy of the project (used to create the demo)

Src='/var/www/secure/takos-core'
Dst='/var/www/secure/takos-web/demo'

Clean='fs scripts .bzr .bzrignore'

if [ -d "$Src" ]; then
    cd $Src
    if [ -d "$Dst" ]; then
        cp -R $Src/* $Dst/. && cd $Dst
        for File in $Clean; do
            echo "Deleting $File"
            rm -r $File 2> /dev/null
        done
        sh $Src/scripts/makePermissions.sh $Dst
    else
        echo "$Dst does not exist !"
    fi
else
    echo "$Src does not exist !"
fi
