#!/bin/sh
# @author: Aubort Jean-Baptiste <aubort.jeanbaptiste@gmail.com> 21.11.2008
# Installation for production

TakosUser='user'
SysUser='rorist'
SysGroup='www-data'
Fs='fs'
Dir='/var/www/secure/takos-core'
Xfiles="$Fs/$TakosUser/Desktop $Fs/$TakosUser/Documents $Fs/$TakosUser/Data"

if [ -d "$1" ]; then
    Dir="$1"
fi

# Create directories
if [ -d "$Dir" ]; then
    cd $Dir
    mkdir -p $Xfiles
else
    echo "$Dir does not exist !"
    exit 1
fi

# Create desktop links
find "$Dir/programs" -name "*.lnk" -exec cp {} "$Fs/$TakosUser/Desktop/." \;

# Permissions 
chown -R $SysUser:$SysGroup *
chmod -R 740 scripts index.php
chmod -R 750 Kernel
chmod -R 770 programs
chmod 700 takos.kpf .bzrignore

